Lattice Grid Buy a licence

demo D175

Colour schemes

Built-in palettes, the default colour-blind safe

scheme: 'default' · 'bright' · 'earth' · 'mono'

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
  ];

  const rows = [/* circuit records */];

  function App() {
    const gridRef = React.useRef(null);

    // scheme picks the palette. The default is the colour-blind-safe one. Each
    // chart reads the live grid through the ref, so a filter redraws them together.
    React.useEffect(() => {
      const grid = gridRef.current.grid;
      createChart({ grid, container: '#default', type: 'pie', x: 'region', y: 'charge', scheme: 'default', title: 'default' });
      createChart({ grid, container: '#bright',  type: 'pie', x: 'region', y: 'charge', scheme: 'bright',  title: 'bright' });
      createChart({ grid, container: '#earth',   type: 'pie', x: 'region', y: 'charge', scheme: 'earth',   title: 'earth' });
      createChart({ grid, container: '#mono',    type: 'pie', x: 'region', y: 'charge', scheme: 'mono',    title: 'mono' });
    }, []);

    return (
      <>
        <div style={{ display: 'grid', gridTemplateColumns: 'repeat(2, 1fr)', gap: '14px', height: '210px' }}>
          <div id="default" />
          <div id="bright" />
          <div id="earth" />
          <div id="mono" />
        </div>
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          columns={columns}
          rows={rows}
          style={{ height: '340px', marginTop: '14px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D175

Colour schemes

Built-in palettes, the default colour-blind safe

scheme: 'default' · 'bright' · 'earth' · 'mono'

Building…
Loading a live grid…

The configuration

<script>
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeAction from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/svelte.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const lattice = createLatticeAction({ createGrid });

  let defaultEl, brightEl, earthEl, monoEl;

  const config = {
    rowKey: 'id',
    columns: [
      { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'status', title: 'Status', filter: { type: 'set' } },
      { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
      { field: 'charge', title: 'Monthly charge', type: 'number',
        format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
    ],
    rows,  // an array of circuit records
    // onGrid hands over the live grid the moment it is created. Every chart is
    // built from it and follows the grid's filters and sort; scheme picks the
    // palette. The default scheme is the colour-blind-safe palette.
    onGrid: (grid) => {
      createChart({ grid, container: defaultEl, type: 'pie', x: 'region', y: 'charge', scheme: 'default' });
      createChart({ grid, container: brightEl,  type: 'pie', x: 'region', y: 'charge', scheme: 'bright' });
      createChart({ grid, container: earthEl,   type: 'pie', x: 'region', y: 'charge', scheme: 'earth' });
      createChart({ grid, container: monoEl,    type: 'pie', x: 'region', y: 'charge', scheme: 'mono' });
    },
  };
</script>

<svelte:head>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">
</svelte:head>

<div style="display: grid; grid-template-columns: repeat(2, 1fr); gap: 14px; height: 210px">
  <div bind:this={defaultEl}></div>
  <div bind:this={brightEl}></div>
  <div bind:this={earthEl}></div>
  <div bind:this={monoEl}></div>
</div>
<div use:lattice={config} style="height: 340px; margin-top: 14px"></div>

Lattice Grid Buy a licence

demo D175

Colour schemes

Built-in palettes, the default colour-blind safe

scheme: 'default' · 'bright' · 'earth' · 'mono'

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'status', title: 'Status', filter: { type: 'set' } },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
];

const rows = [/* circuit records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div style="display:grid;grid-template-columns:repeat(2, 1fr);gap:14px;height:210px">' +
    '<div id="default"></div>' +
    '<div id="bright"></div>' +
    '<div id="earth"></div>' +
    '<div id="mono"></div>' +
    '</div>' +
    '<lattice-grid [config]="grid" style="display:block;height:340px;margin-top:14px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    columns: columns,
    rows: rows,
  };

  ngAfterViewInit() {
    const grid = this.gridRef.grid;
    createChart({ grid, container: '#default', type: 'pie', x: 'region', y: 'charge', scheme: 'default', title: 'default' });
    createChart({ grid, container: '#bright',  type: 'pie', x: 'region', y: 'charge', scheme: 'bright',  title: 'bright' });
    createChart({ grid, container: '#earth',   type: 'pie', x: 'region', y: 'charge', scheme: 'earth',   title: 'earth' });
    createChart({ grid, container: '#mono',    type: 'pie', x: 'region', y: 'charge', scheme: 'mono',    title: 'mono' });
  }
}

bootstrapApplication(AppComponent);